## snort 3.1.82.0

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.4.3)
project (snort CXX C)

set (VERSION_MAJOR 3)
set (VERSION_MINOR 1)
set (VERSION_PATCH 82)
set (VERSION_SUBLEVEL 0)
set (VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${VERSION_SUBLEVEL}")

if (DEFINED VERSION_BUILD)
    set (BUILD "${VERSION_BUILD}")
endif ()

set (CMAKE_CXX_STANDARD 17)
set (CMAKE_CXX_STANDARD_REQUIRED ON)
set (CMAKE_CXX_EXTENSIONS OFF)

set (CMAKE_C_STANDARD 99)
set (CMAKE_C_STANDARD_REQUIRED ON)
set (CMAKE_C_EXTENSIONS ON)

set (CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
# Pull in definitions of various install directories
include (GNUInstallDirs)
include (${CMAKE_MODULE_PATH}/macros.cmake)
include (${CMAKE_MODULE_PATH}/create_options.cmake)
include (${CMAKE_MODULE_PATH}/include_libraries.cmake)
include (${CMAKE_MODULE_PATH}/platforms.cmake)
include (${CMAKE_MODULE_PATH}/configure_options.cmake)
#include (${CMAKE_MODULE_PATH}/compiler_features.cmake)
include (${CMAKE_MODULE_PATH}/sanity_checks.cmake)

set (INSTALL_SUFFIX "${CMAKE_PROJECT_NAME}")
set (INCLUDE_INSTALL_PATH "${CMAKE_INSTALL_INCLUDEDIR}/${INSTALL_SUFFIX}")
set (LIB_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}/${INSTALL_SUFFIX}")
set (PLUGIN_INSTALL_PATH "${LIB_INSTALL_PATH}/plugins")

configure_file (
    "${PROJECT_SOURCE_DIR}/config.cmake.h.in"
    "${PROJECT_BINARY_DIR}/config.h"
)

add_definitions( -DHAVE_CONFIG_H )

# Set these after all tests are done but *before* any subdirectories are included
#  or other targets declared.
string(APPEND CMAKE_C_FLAGS " ${EXTRA_C_FLAGS}")
string(APPEND CMAKE_CXX_FLAGS " ${EXTRA_CXX_FLAGS}")
string(APPEND CMAKE_EXE_LINKER_FLAGS " ${EXTRA_LINKER_FLAGS}")
string(APPEND CMAKE_MODULE_LINKER_FLAGS " ${EXTRA_LINKER_FLAGS}")

include_directories (${PROJECT_BINARY_DIR})
include_directories (${PROJECT_SOURCE_DIR})

if (ENABLE_UNIT_TESTS)
    include(CTest)
endif (ENABLE_UNIT_TESTS)

if (ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS)
    add_custom_target (check COMMAND ${CMAKE_CTEST_COMMAND})
endif (ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS)

add_subdirectory (src)
add_subdirectory (tools)
add_subdirectory (lua)
add_subdirectory (daqs)

if ( MAKE_DOC )
    add_subdirectory (doc)
endif ( MAKE_DOC )

# Miscellaneous stuff.  Does NOT directly affect Snort's build environment.
include (${CMAKE_MODULE_PATH}/packaging_data.cmake)
include (${CMAKE_MODULE_PATH}/create_pkg_config.cmake)

# uninstall target
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

string(TOUPPER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_UPPER)

message("
-------------------------------------------------------")
if (DEFINED BUILD)
    message("${CMAKE_PROJECT_NAME} version ${VERSION} build ${BUILD}")
else()
    message("${CMAKE_PROJECT_NAME} version ${VERSION}")
endif()
message("
Install options:
    prefix:     ${CMAKE_INSTALL_PREFIX}
    includes:   ${CMAKE_INSTALL_FULL_INCLUDEDIR}/${INSTALL_SUFFIX}
    plugins:    ${CMAKE_INSTALL_FULL_LIBDIR}/${INSTALL_SUFFIX}

Compiler options:
    CC:             ${CMAKE_C_COMPILER}
    CXX:            ${CMAKE_CXX_COMPILER}
    CFLAGS:         ${CMAKE_C_FLAGS} ${CMAKE_C_FLAGS_${CMAKE_BUILD_TYPE_UPPER}}
    CXXFLAGS:       ${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE_UPPER}}
    EXE_LDFLAGS:    ${CMAKE_EXE_LINKER_FLAGS}
    MODULE_LDFLAGS: ${CMAKE_MODULE_LINKER_FLAGS}

Feature options:\
")

if (ENABLE_STATIC_DAQ)
    message("\
    DAQ Modules:    Static (${DAQ_STATIC_MODULES})")
else ()
    message("\
    DAQ Modules:    Dynamic")
endif ()

if (HAVE_ATOMIC)
    message("\
    libatomic:      User-specified")
else ()
    message("\
    libatomic:      System-provided")
endif ()

if (HAVE_HYPERSCAN)
    message("\
    Hyperscan:      ON")
else ()
    message("\
    Hyperscan:      OFF")
endif ()

if (HAVE_ICONV)
    message("\
    ICONV:          ON")
else ()
    message("\
    ICONV:          OFF")
endif ()

if (HAVE_LIBUNWIND)
    message("\
    Libunwind:      ON")
else ()
    message("\
    Libunwind:      OFF")
endif ()

if (HAVE_LZMA)
    message("\
    LZMA:           ON")
else ()
    message("\
    LZMA:           OFF")
endif ()

if (USE_TIRPC)
    message("\
    RPC DB:         TIRPC")
else ()
    message("\
    RPC DB:         Built-in")
endif ()

if (HAVE_SAFEC)
    message("\
    SafeC:          ON")
else ()
    message("\
    SafeC:          OFF")
endif ()

if (HAVE_TCMALLOC)
    message("\
    TCMalloc:       ON")
else ()
    message("\
    TCMalloc:       OFF")
endif ()

if (HAVE_JEMALLOC)
    message("\
    JEMalloc:       ON")
else ()
    message("\
    JEMalloc:       OFF")
endif ()

if (HAVE_UUID)
    message("\
    UUID:           ON")
else ()
    message("\
    UUID:           OFF")
endif ()

if (HAVE_NUMA)
    message("\
    NUMA:           ON")
else ()
    message("\
    NUMA:           OFF")
endif ()

if (HAVE_LIBML)
    message("\
    LibML:          ON")
else ()
    message("\
    LibML:          OFF")
endif ()

message("-------------------------------------------------------\n")

=== src/CMakeLists.txt ===

# keeping track of external libraries seperately for use in pkg-config.
set(EXTERNAL_LIBRARIES
    ${DAQ_LIBRARIES}
    ${DNET_LIBRARIES}
    ${CLANG_CXX_LIBRARY}
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT} # GCC says we must link to the threads library
    ${HWLOC_LIBRARIES}
    ${LUAJIT_LIBRARIES}
    ${OPENSSL_CRYPTO_LIBRARY}
    ${PCAP_LIBRARIES}
    ${PCRE_LIBRARIES}
    ${ZLIB_LIBRARIES}
)

set(EXTERNAL_INCLUDES
    ${DAQ_INCLUDE_DIR}
    ${DNET_INCLUDE_DIR}
    ${FLEX_INCLUDES}
    ${HWLOC_INCLUDE_DIRS}
    ${OPENSSL_INCLUDE_DIR}
    ${PCAP_INCLUDE_DIR}
    ${PCRE_INCLUDE_DIR}
    ${ZLIB_INCLUDE_DIRS}
)

if ( ENABLE_STATIC_DAQ )
    LIST(APPEND EXTERNAL_LIBRARIES ${DAQ_STATIC_MODULE_LIBS})
endif ()

if ( HAVE_ATOMIC )
    LIST(APPEND EXTERNAL_LIBRARIES ${ATOMIC_LIBRARIES})
endif()

if ( HAVE_HYPERSCAN )
    LIST(APPEND EXTERNAL_LIBRARIES ${HS_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${HS_INCLUDE_DIRS})
endif ()

if ( HAVE_ICONV )
    LIST(APPEND EXTERNAL_LIBRARIES ${ICONV_LIBRARY})
    LIST(APPEND EXTERNAL_INCLUDES ${ICONV_INCLUDE_DIR})
endif ()

if ( HAVE_LIBUNWIND )
    LIST(APPEND EXTERNAL_LIBRARIES ${LIBUNWIND_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${LIBUNWIND_INCLUDE_DIRS})
endif ()

if ( HAVE_LZMA )
    LIST(APPEND EXTERNAL_LIBRARIES ${LIBLZMA_LIBRARIES})
endif()

if ( HAVE_NUMA )
    LIST(APPEND EXTERNAL_INCLUDES ${NUMA_INCLUDE_DIRS})
    LIST(APPEND EXTERNAL_LIBRARIES ${NUMA_LIBRARIES})
endif()

if ( HAVE_SAFEC )
    LIST(APPEND EXTERNAL_LIBRARIES ${SAFEC_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${SAFEC_INCLUDE_DIR})
endif ()

if ( HAVE_UUID )
    LIST(APPEND EXTERNAL_LIBRARIES ${UUID_LIBRARY})
    LIST(APPEND EXTERNAL_INCLUDES ${UUID_INCLUDE_DIR})
endif ()

if ( USE_TIRPC )
    LIST(APPEND EXTERNAL_LIBRARIES ${TIRPC_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${TIRPC_INCLUDE_DIRS})
endif ()

if ( HAVE_LIBML )
    LIST(APPEND EXTERNAL_LIBRARIES ${ML_LIBRARIES})
    LIST(APPEND EXTERNAL_INCLUDES ${ML_INCLUDE_DIRS})
endif ()

include_directories(BEFORE ${LUAJIT_INCLUDE_DIR})
include_directories(AFTER ${EXTERNAL_INCLUDES})

# prepending all of these to ensure they are included before External Libs
include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})
include_directories(BEFORE network_inspectors)

if ( ENABLE_UNIT_TESTS )
    enable_testing()
endif ( ENABLE_UNIT_TESTS )

if ( ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS )
    set( UNIT_TESTS_LIBRARIES $<TARGET_OBJECTS:catch_tests>)
    add_subdirectory(catch)
endif ( ENABLE_UNIT_TESTS OR ENABLE_BENCHMARK_TESTS )

add_subdirectory(actions)
add_subdirectory(codecs)
add_subdirectory(control)
add_subdirectory(detection)
add_subdirectory(dump_config)
add_subdirectory(events)
add_subdirectory(file_api)
add_subdirectory(filters)
add_subdirectory(flow)
add_subdirectory(framework)
add_subdirectory(hash)
add_subdirectory(js_norm)
add_subdirectory(latency)
add_subdirectory(log)
add_subdirectory(main)
add_subdirectory(managers)
add_subdirectory(memory)
add_subdirectory(mime)
add_subdirectory(packet_io)
add_subdirectory(parser)
add_subdirectory(payload_injector)
add_subdirectory(ports)
add_subdirectory(protocols)
add_subdirectory(sfip)
add_subdirectory(sfrt)
add_subdirectory(service_inspectors)
add_subdirectory(stream)
add_subdirectory(target_based)
add_subdirectory(host_tracker)
add_subdirectory(pub_sub)
add_subdirectory(time)
add_subdirectory(profiler)
add_subdirectory(trace)
add_subdirectory(utils)
add_subdirectory(helpers)
add_subdirectory(lua)
add_subdirectory(decompress)
add_subdirectory(ips_options)
add_subdirectory(loggers)
add_subdirectory(network_inspectors)
add_subdirectory(policy_selectors)
add_subdirectory(search_engines)
add_subdirectory(side_channel)
add_subdirectory(connectors)


# FIXIT-L Delegate building out the target objects list to subdirectories

#  The main Snort executable
add_executable( snort
    main.h
    main.cc
    $<TARGET_OBJECTS:codecs>
    $<TARGET_OBJECTS:connectors>
    $<TARGET_OBJECTS:control>
    $<TARGET_OBJECTS:decompress>
    $<TARGET_OBJECTS:detection>
    $<TARGET_OBJECTS:dump_config>
    $<TARGET_OBJECTS:events>
    $<TARGET_OBJECTS:file_api>
    $<TARGET_OBJECTS:file_connector>
    $<TARGET_OBJECTS:filter>
    $<TARGET_OBJECTS:flow>
    $<TARGET_OBJECTS:framework>
    $<TARGET_OBJECTS:hash>
    $<TARGET_OBJECTS:helpers>
    $<TARGET_OBJECTS:host_tracker>
    $<TARGET_OBJECTS:ips_actions>
    $<TARGET_OBJECTS:ips_options>
    $<TARGET_OBJECTS:js_norm>
    $<TARGET_OBJECTS:latency>
    $<TARGET_OBJECTS:log>
    $<TARGET_OBJECTS:loggers>
    $<TARGET_OBJECTS:lua>
    $<TARGET_OBJECTS:main>
    $<TARGET_OBJECTS:managers>
    $<TARGET_OBJECTS:memory>
    $<TARGET_OBJECTS:mime>
    $<TARGET_OBJECTS:network_inspectors>
    $<TARGET_OBJECTS:policy_selectors>
    $<TARGET_OBJECTS:packet_io>
    $<TARGET_OBJECTS:parser>
    $<TARGET_OBJECTS:payload_injector>
    $<TARGET_OBJECTS:ports>
    $<TARGET_OBJECTS:profiler>
    $<TARGET_OBJECTS:protocols>
    $<TARGET_OBJECTS:pub_sub>
    $<TARGET_OBJECTS:search_engines>
    $<TARGET_OBJECTS:service_inspectors>
    $<TARGET_OBJECTS:sfip>
    $<TARGET_OBJECTS:sfrt>
    $<TARGET_OBJECTS:side_channel>
    $<TARGET_OBJECTS:stream>
    $<TARGET_OBJECTS:stream_base>
    $<TARGET_OBJECTS:stream_ip>
    $<TARGET_OBJECTS:stream_icmp>
    $<TARGET_OBJECTS:stream_tcp>
    $<TARGET_OBJECTS:stream_udp>
    $<TARGET_OBJECTS:stream_user>
    $<TARGET_OBJECTS:stream_file>
    $<TARGET_OBJECTS:stream_paf>
    $<TARGET_OBJECTS:target_based>
    $<TARGET_OBJECTS:tcp_connector>
    $<TARGET_OBJECTS:time>
    $<TARGET_OBJECTS:trace>
    $<TARGET_OBJECTS:utils>
    ${STATIC_CODEC_PLUGINS}
    ${STATIC_NETWORK_INSPECTOR_PLUGINS}
    ${STATIC_SERVICE_INSPECTOR_PLUGINS}
    ${STATIC_POLICY_SELECTOR_PLUGINS}
    ${UNIT_TESTS_LIBRARIES}
)

#[[
message("
    STATIC_CODEC_PLUGINS = ${STATIC_CODEC_PLUGINS}
    STATIC_NETWORK_INSPECTOR_PLUGINS = ${STATIC_NETWORK_INSPECTOR_PLUGINS}
    STATIC_SERVICE_INSPECTOR_PLUGINS = ${STATIC_SERVICE_INSPECTOR_PLUGINS}
")
]]

target_link_libraries( snort
    ${EXTERNAL_LIBRARIES}
    ${EXTRA_LIBRARIES}
)

# Solaris requires libnsl and libsocket for various network-related library functions
if ( CMAKE_SYSTEM_NAME STREQUAL SunOS )
    target_link_libraries(snort nsl socket)
endif ()

#  setting export properties
set_property(TARGET snort APPEND PROPERTY INTERFACE_INCLUDE_DIRECTORIES
    ${LUAJIT_INCLUDE_DIR}
    ${EXTERNAL_INCLUDES}
    # The installed path '${INCLUDE_INSTALL_PATH}'' is added below with 'install (... snort ...)'
)

set_property(TARGET snort APPEND PROPERTY INTERFACE_COMPILE_OPTIONS "${CMAKE_CXX_FLAGS}")

set_property(TARGET snort PROPERTY ENABLE_EXPORTS 1)

install (TARGETS snort
    # EXPORT snortexe
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

# FIXIT-L Restore CMake export information
#install (EXPORT snortexe
#    DESTINATION ${CMAKE_INSTALL_LIBDIR}/snort
#    FILE snort.cmake
#)

=== src/detection/CMakeLists.txt ===

set (DETECTION_INCLUDES
    detect.h
    detection_engine.h
    detection_options.h
    detection_util.h
    detect_trace.h
    ips_context.h
    ips_context_chain.h
    ips_context_data.h
    regex_offload.h
    rule_option_types.h
    rules.h
    signature.h
    treenodes.h
    pattern_match_data.h
)

add_library (detection OBJECT
    ${DETECTION_INCLUDES}
    context_switcher.cc
    context_switcher.h
    detect.cc
    detection_engine.cc
    detection_module.cc
    detection_module.h
    detection_options.cc
    detection_options.h
    detection_util.cc
    detect_trace.cc
    fp_config.cc
    fp_config.h
    fp_create.cc
    fp_create.h
    fp_detect.cc
    fp_detect.h
    fp_utils.cc
    fp_utils.h
    ips_context.cc
    ips_context_chain.cc
    ips_context_data.cc
    pcrm.cc
    pcrm.h
    regex_offload.cc
    rtn_checks.cc
    rtn_checks.h
    rules.cc
    service_map.cc
    service_map.h
    sfrim.cc
    sfrim.h
    signature.cc
    treenodes.cc
    tag.cc
    tag.h
)

install(FILES ${DETECTION_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/detection"
)

=== src/hash/CMakeLists.txt ===

set (HASH_INCLUDES
    ghash.h
    hashes.h
    hash_defs.h
    hash_key_operations.h
    lru_cache_local.h
    lru_cache_shared.h
    lru_segmented_cache_shared.h
    xhash.h
)

add_library( hash OBJECT
    ${HASH_INCLUDES}
    ghash.cc
    hashes.cc
    hash_lru_cache.cc
    hash_lru_cache.h
    hash_key_operations.cc
    lru_cache_shared.cc
    primetable.cc
    primetable.h
    xhash.cc
    zhash.cc
    zhash.h
)

install(FILES ${HASH_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/hash"
)

add_subdirectory ( test )

=== src/host_tracker/CMakeLists.txt ===
set (HOST_TRACKER_INCLUDES
    cache_allocator.h
    cache_interface.h
    host_cache.h
    host_cache_segmented.h
    host_tracker.h
)

add_library( host_tracker OBJECT
    ${HOST_TRACKER_INCLUDES}
    cache_allocator.cc
    host_cache.cc
    host_cache_module.cc
    host_cache_module.h
    host_cache_segmented.h
    host_tracker_module.cc
    host_tracker_module.h
    host_tracker.cc
)

add_subdirectory ( test )

install(FILES ${HOST_TRACKER_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/host_tracker"
)

=== src/ips_options/CMakeLists.txt ===
set(IPS_INCLUDES
    extract.h
)

SET( PLUGIN_LIST
    ips_ack.cc
    ips_base64.cc
    ips_ber_data.cc
    ips_ber_skip.cc
    ips_bufferlen.cc
    ips_byte_extract.cc
    ips_byte_jump.cc
    ips_byte_math.cc
    ips_byte_test.cc
    ips_cvs.cc
    ips_enable.cc
    ips_file_type.cc
    ips_flags.cc
    ips_fragbits.cc
    ips_fragoffset.cc
    ips_gid.cc
    ips_icmp_id.cc
    ips_icmp_seq.cc
    ips_icode.cc
    ips_id.cc
    ips_ipopts.cc
    ips_ip_proto.cc
    ips_isdataat.cc
    ips_itype.cc
    ips_msg.cc
    ips_pcre.cc
    ips_priority.cc
    ips_raw_data.cc
    ips_rem.cc
    ips_rev.cc
    ips_rpc.cc
    ips_seq.cc
    ips_sid.cc
    ips_soid.cc
    ips_tag.cc
    ips_target.cc
    ips_tos.cc
    ips_ttl.cc
    ips_window.cc
    ips_vba_data.cc
    ips_vba_data.h
)


set (IPS_SOURCES
    ${IPS_INCLUDES}
    extract.cc
    ips_classtype.cc
    ips_content.cc
    ips_detection_filter.cc
    ips_dsize.cc
    ips_file_data.cc
    ips_file_meta.cc
    ips_flow.cc
    ips_flowbits.cc
    ips_flowbits.h
    ips_hash.cc
    ips_js_data.cc
    ips_luajit.cc
    ips_metadata.cc
    ips_options.cc
    ips_options.h
    ips_pkt_data.cc
    ips_reference.cc
    ips_replace.cc
    ips_service.cc
    ips_so.cc
    ips_vba_data.cc
    ips_vba_data.h
)

if ( HAVE_HYPERSCAN )
    set(PLUGIN_LIST
        ${PLUGIN_LIST}
        ips_regex.cc
        ips_sd_pattern.cc
        sd_credit_card.cc sd_credit_card.h)
endif ()

if (STATIC_IPS_OPTIONS)

    add_library ( ips_options OBJECT
        ${IPS_SOURCES}
        ${OPTION_LIST}
        ${PLUGIN_LIST}
    )

else (STATIC_IPS_OPTIONS)

    add_library ( ips_options OBJECT
        ${IPS_SOURCES}
        ${OPTION_LIST}
    )

    add_dynamic_module(ips_ack ips_options ips_ack.cc)
    add_dynamic_module(ips_base64 ips_options ips_base64.cc)
    add_dynamic_module(ips_ber_data ips_options ips_ber_data.cc)
    add_dynamic_module(ips_ber_skip ips_options ips_ber_skip.cc)
    add_dynamic_module(ips_bufferlen ips_options ips_bufferlen.cc)
    add_dynamic_module(ips_byte_extract ips_options extract.cc ips_byte_extract.cc)
    add_dynamic_module(ips_byte_jump ips_options extract.cc ips_byte_jump.cc)
    add_dynamic_module(ips_byte_math ips_options extract.cc ips_byte_math.cc)
    add_dynamic_module(ips_byte_test ips_options extract.cc ips_byte_test.cc)
    add_dynamic_module(ips_cvs ips_options ips_cvs.cc)
    add_dynamic_module(ips_enable ips_options ips_enable.cc)
    add_dynamic_module(ips_file_type ips_options ips_file_type.cc)
    add_dynamic_module(ips_flags ips_options ips_flags.cc)
    add_dynamic_module(ips_fragbits ips_options ips_fragbits.cc)
    add_dynamic_module(ips_fragoffset ips_options ips_fragoffset.cc)
    add_dynamic_module(ips_gid ips_options ips_gid.cc)
    add_dynamic_module(ips_icode ips_options ips_icode.cc)
    add_dynamic_module(ips_icmp_id ips_options ips_icmp_id.cc)
    add_dynamic_module(ips_icmp_seq ips_options ips_icmp_seq.cc)
    add_dynamic_module(ips_id ips_options ips_id.cc)
    add_dynamic_module(ips_ipopts ips_options ips_ipopts.cc)
    add_dynamic_module(ips_ip_proto ips_options ips_ip_proto.cc)
    add_dynamic_module(ips_isdataat ips_options ips_isdataat.cc)
    add_dynamic_module(ips_itype ips_options ips_itype.cc)
    add_dynamic_module(ips_msg ips_options ips_msg.cc)
    add_dynamic_module(ips_pcre ips_options ips_pcre.cc)
    add_dynamic_module(ips_priority ips_options ips_priority.cc)
    add_dynamic_module(ips_raw_data ips_options ips_raw_data.cc)
    add_dynamic_module(ips_rem ips_options ips_rem.cc)
    add_dynamic_module(ips_rev ips_options ips_rev.cc)
    add_dynamic_module(ips_rpc ips_options ips_rpc.cc)
    add_dynamic_module(ips_sid ips_options ips_sid.cc)
    add_dynamic_module(ips_seq ips_options ips_seq.cc)
    add_dynamic_module(ips_soid ips_options ips_soid.cc)
    add_dynamic_module(ips_tag ips_options ips_tag.cc)
    add_dynamic_module(ips_target ips_options ips_target.cc)
    add_dynamic_module(ips_tos ips_options ips_tos.cc)
    add_dynamic_module(ips_ttl ips_options ips_ttl.cc)
    add_dynamic_module(ips_window ips_options ips_window.cc)
if ( HAVE_HYPERSCAN )
    add_dynamic_module(ips_regex ips_options ips_regex.cc)
    add_dynamic_module(ips_sd_pattern ips_options ips_sd_pattern.cc sd_credit_card.cc sd_credit_card.h)
endif ( HAVE_HYPERSCAN )

endif (STATIC_IPS_OPTIONS)

add_subdirectory(test)

install(FILES ${IPS_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/ips_options/"
)

=== src/network_inspectors/CMakeLists.txt ===

add_subdirectory(appid)
add_subdirectory(arp_spoof)
add_subdirectory(binder)
add_subdirectory(kaizen)
add_subdirectory(normalize)
add_subdirectory(packet_capture)
add_subdirectory(packet_tracer)
add_subdirectory(perf_monitor)
add_subdirectory(port_scan)
add_subdirectory(reputation)
add_subdirectory(rna)

if(STATIC_INSPECTORS)
    set(STATIC_INSPECTOR_OBJS
        $<TARGET_OBJECTS:arp_spoof>
        $<TARGET_OBJECTS:packet_capture>
        $<TARGET_OBJECTS:perf_monitor>
    )
endif()

set(STATIC_NETWORK_INSPECTOR_PLUGINS
    $<TARGET_OBJECTS:appid>
    $<TARGET_OBJECTS:binder>
    $<TARGET_OBJECTS:kaizen>
    $<TARGET_OBJECTS:normalize>
    $<TARGET_OBJECTS:packet_tracer>
    $<TARGET_OBJECTS:port_scan>
    $<TARGET_OBJECTS:reputation>
    $<TARGET_OBJECTS:rna>
    ${STATIC_INSPECTOR_OBJS}
    CACHE INTERNAL "STATIC_NETWORK_INSPECTOR_PLUGINS"
)

add_library( network_inspectors OBJECT
    network_inspectors.cc
    network_inspectors.h
)

=== src/pub_sub/CMakeLists.txt ===
set (PUB_SUB_INCLUDES
    appid_debug_log_event.h
    appid_event_ids.h
    appid_events.h
    assistant_gadget_event.h
    cip_events.h
    data_decrypt_event.h
    daq_message_event.h
    dcerpc_events.h
    dhcp_events.h
    eve_process_event.h
    expect_events.h
    external_event_ids.h
    finalize_packet_event.h
    http_event_ids.h
    http_events.h
    http_request_body_event.h
    intrinsic_event_ids.h
    netflow_event.h
    opportunistic_tls_event.h
    packet_events.h
    reputation_events.h
    rna_events.h
    sip_events.h
    stream_event_ids.h
    smb_events.h
    ssh_events.h
    ssl_events.h
    dns_events.h
)

add_library( pub_sub OBJECT
    ${PUB_SUB_INCLUDES}
    cip_events.cc
    http_events.cc
    dns_events.cc
    http_request_body_event.cc
    sip_events.cc
)

install (FILES ${PUB_SUB_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/pub_sub"
)

add_subdirectory ( test )

=== src/service_inspectors/CMakeLists.txt ===

add_subdirectory(back_orifice)
add_subdirectory(cip)
add_subdirectory(dce_rpc)
add_subdirectory(dnp3)
add_subdirectory(dns)
add_subdirectory(ftp_telnet)
add_subdirectory(gtp)
add_subdirectory(http_inspect)
add_subdirectory(http2_inspect)
add_subdirectory(iec104)
add_subdirectory(imap)
add_subdirectory(mms)
add_subdirectory(modbus)
add_subdirectory(netflow)
add_subdirectory(pop)
add_subdirectory(rpc_decode)
add_subdirectory(s7commplus)
add_subdirectory(sip)
add_subdirectory(smtp)
add_subdirectory(ssh)
add_subdirectory(ssl)
add_subdirectory(wizard)

if (STATIC_INSPECTORS)
    set (STATIC_INSPECTOR_OBJS
        $<TARGET_OBJECTS:back_orifice>
        $<TARGET_OBJECTS:cip>
        $<TARGET_OBJECTS:dce_rpc>
        $<TARGET_OBJECTS:dnp3>
        $<TARGET_OBJECTS:ftp_telnet>
        $<TARGET_OBJECTS:gtp_inspect>
        $<TARGET_OBJECTS:iec104>
        $<TARGET_OBJECTS:imap>
        $<TARGET_OBJECTS:mms>
        $<TARGET_OBJECTS:modbus>
        $<TARGET_OBJECTS:netflow>
        $<TARGET_OBJECTS:pop>
        $<TARGET_OBJECTS:rpc_decode>
        $<TARGET_OBJECTS:s7commplus>
        $<TARGET_OBJECTS:smtp>
        $<TARGET_OBJECTS:ssh>
        $<TARGET_OBJECTS:wizard>
    )
endif()

set(STATIC_SERVICE_INSPECTOR_PLUGINS
    $<TARGET_OBJECTS:http_inspect>
    $<TARGET_OBJECTS:http2_inspect>
    $<TARGET_OBJECTS:sip>
    $<TARGET_OBJECTS:ssl>
    $<TARGET_OBJECTS:dns>
    ${STATIC_INSPECTOR_OBJS}
    CACHE INTERNAL "STATIC_SERVICE_INSPECTOR_PLUGINS"
)

add_library( service_inspectors OBJECT
    service_inspectors.cc
    service_inspectors.h
)

=== src/utils/CMakeLists.txt ===

set( UTIL_INCLUDES
    boyer_moore.h
    cpp_macros.h
    endian.h
    event_gen.h
    infractions.h
    kmap.h
    memcap_allocator.h
    primed_allocator.h
    safec.h
    sflsq.h
    stats.h
    util.h
    util_ber.h
    util_cstring.h
    util_unfold.h
    util_utf.h
    util_numa.h
)

add_library ( utils OBJECT
    ${UTIL_INCLUDES}
    ${SNPRINTF_SOURCES}
    boyer_moore.cc
    dnet_header.h
    kmap.cc
    sflsq.cc
    snort_bounds.h
    stats.cc
    streambuf.cc
    streambuf.h
    util.cc
    util_ber.cc
    util_cstring.cc
    util_jsnorm.cc
    util_jsnorm.h
    util_net.cc
    util_net.h
    util_unfold.cc
    util_utf.cc
    util_numa.h
    ${TEST_FILES}
)

install (FILES ${UTIL_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/utils"
)

add_subdirectory(test)

=== src/network_inspectors/appid/CMakeLists.txt ===
set (APPID_INCLUDES
    appid_api.h
    appid_app_descriptor.h
    appid_debug.h
    appid_dns_session.h
    appid_http_session.h
    appid_session_api.h
    appid_types.h
    application_ids.h
    tp_appid_module_api.h
    tp_appid_session_api.h
    tp_appid_types.h
)

set ( APPID_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR} )

set ( CP_APPID_SOURCES
    client_plugins/client_app_bit.cc
    client_plugins/client_app_bit.h
    client_plugins/client_app_bit_tracker.cc
    client_plugins/client_app_bit_tracker.h
    client_plugins/client_detector.cc
    client_plugins/client_detector.h
    client_plugins/client_app_msn.cc
    client_plugins/client_app_msn.h
    client_plugins/client_app_rtp.cc
    client_plugins/client_app_rtp.h
    client_plugins/client_app_timbuktu.cc
    client_plugins/client_app_timbuktu.h
    client_plugins/client_app_tns.cc
    client_plugins/client_app_tns.h
    client_plugins/client_app_vnc.cc
    client_plugins/client_app_vnc.h
    client_plugins/client_detector.cc
    client_plugins/client_detector.h
    client_plugins/client_discovery.cc
    client_plugins/client_discovery.h
    client_plugins/eve_ca_patterns.cc
    client_plugins/eve_ca_patterns.h
)

set ( SP_APPID_SOURCES
    service_plugins/alpn_patterns.cc
    service_plugins/alpn_patterns.h
    service_plugins/dcerpc.cc
    service_plugins/dcerpc.h
    service_plugins/service_bgp.cc
    service_plugins/service_bgp.h
    service_plugins/service_bit.cc
    service_plugins/service_bit.h
    service_plugins/service_bootp.cc
    service_plugins/service_bootp.h
    service_plugins/service_dcerpc.cc
    service_plugins/service_dcerpc.h
    service_plugins/service_detector.cc
    service_plugins/service_detector.h
    service_plugins/service_discovery.cc
    service_plugins/service_discovery.h
    service_plugins/service_ftp.cc
    service_plugins/service_ftp.h
    service_plugins/service_irc.cc
    service_plugins/service_irc.h
    service_plugins/service_lpr.cc
    service_plugins/service_lpr.h
    service_plugins/service_mdns.cc
    service_plugins/service_mdns.h
    service_plugins/service_mysql.cc
    service_plugins/service_mysql.h
    service_plugins/service_netbios.cc
    service_plugins/service_netbios.h
    service_plugins/service_nntp.cc
    service_plugins/service_nntp.h
    service_plugins/service_ntp.cc
    service_plugins/service_ntp.h
    service_plugins/service_radius.cc
    service_plugins/service_radius.h
    service_plugins/service_regtest.cc
    service_plugins/service_regtest.h
    service_plugins/service_rexec.cc
    service_plugins/service_rexec.h
    service_plugins/service_rfb.cc
    service_plugins/service_rfb.h
    service_plugins/service_rlogin.cc
    service_plugins/service_rlogin.h
    service_plugins/service_rpc.cc
    service_plugins/service_rpc.h
    service_plugins/service_rshell.cc
    service_plugins/service_rshell.h
    service_plugins/service_rsync.cc
    service_plugins/service_rsync.h
    service_plugins/service_rtmp.cc
    service_plugins/service_rtmp.h
    service_plugins/service_snmp.cc
    service_plugins/service_snmp.h
    service_plugins/service_ssl.cc
    service_plugins/service_ssl.h
    service_plugins/service_telnet.cc
    service_plugins/service_telnet.h
    service_plugins/service_tftp.cc
    service_plugins/service_tftp.h
    service_plugins/service_timbuktu.cc
    service_plugins/service_timbuktu.h
    service_plugins/service_tns.cc
    service_plugins/service_tns.h
)

set ( DP_APPID_SOURCES
    detector_plugins/cip_patterns.cc
    detector_plugins/cip_patterns.h
    detector_plugins/detector_dns.cc
    detector_plugins/detector_dns.h
    detector_plugins/detector_imap.cc
    detector_plugins/detector_imap.h
    detector_plugins/detector_kerberos.cc
    detector_plugins/detector_kerberos.h
    detector_plugins/detector_pattern.cc
    detector_plugins/detector_pattern.h
    detector_plugins/detector_pop3.cc
    detector_plugins/detector_pop3.h
    detector_plugins/detector_sip.cc
    detector_plugins/detector_sip.h
    detector_plugins/detector_smtp.cc
    detector_plugins/detector_smtp.h
    detector_plugins/dns_patterns.cc
    detector_plugins/dns_patterns.h
    detector_plugins/http_url_patterns.cc
    detector_plugins/http_url_patterns.h
    detector_plugins/sip_patterns.cc
    detector_plugins/sip_patterns.h
    detector_plugins/ssh_patterns.cc
    detector_plugins/ssh_patterns.h
    detector_plugins/ssl_patterns.cc
    detector_plugins/ssl_patterns.h
)

set ( UTIL_APPID_SOURCES
    appid_utils/ip_funcs.h
    appid_utils/sf_mlmp.cc
    appid_utils/sf_mlmp.h
)

set ( APPID_SOURCES
    appid_api.cc
    appid_api.h
    appid_app_descriptor.cc
    appid_app_descriptor.h
    appid_config.cc
    appid_config.h
    appid_cip_event_handler.cc
    appid_cip_event_handler.h
    appid_data_decrypt_event_handler.cc
    appid_data_decrypt_event_handler.h
    appid_debug.cc
    appid_debug.h
    appid_detector.cc
    appid_detector.h
    appid_discovery.cc
    appid_discovery.h
    appid_dns_session.h
    appid_eve_process_event_handler.cc
    appid_eve_process_event_handler.h
    appid_ha.cc
    appid_ha.h
    appid_http_session.cc
    appid_http_session.h
    appid_httpx_req_body_event_handler.h
    appid_opportunistic_tls_event_handler.h
    appid_peg_counts.h
    appid_peg_counts.cc
    appid_service_event_handler.cc
    appid_service_event_handler.h
    appid_session.cc
    appid_session.h
    appid_session_api.cc
    appid_session_api.h
    appid_types.h
    appid_inspector.cc
    appid_inspector.h
    appid_module.cc
    appid_module.h
    appid_ssh_event_handler.cc
    appid_ssh_event_handler.h
    appid_stats.cc
    appid_stats.h
    app_info_table.cc
    app_info_table.h
    application_ids.h
    host_port_app_cache.cc
    host_port_app_cache.h
    appid_http_event_handler.cc
    appid_http_event_handler.h
    ips_appid_option.cc
    length_app_cache.h
    lua_detector_api.cc
    lua_detector_api.h
    lua_detector_flow_api.cc
    lua_detector_flow_api.h
    lua_detector_module.cc
    lua_detector_module.h
    lua_detector_util.h
    service_state.cc
    service_state.h
    tp_appid_utils.cc
    tp_lib_handler.cc
    tp_lib_handler.h
    tp_appid_types.h
    tp_appid_session_api.h
    tp_appid_module_api.h
    tp_appid_module_api.cc
)

#if (STATIC_INSPECTORS)
add_library(appid OBJECT
    ${APPID_SOURCES}
    ${CP_APPID_SOURCES}
    ${DP_APPID_SOURCES}
    ${SP_APPID_SOURCES}
    ${UTIL_APPID_SOURCES}
)
#else (STATIC_INSPECTORS)
#    add_dynamic_module(appid inspectors
#        ${APPID_SOURCES}
#        ${CP_APPID_SOURCES}
#        ${DP_APPID_SOURCES}
#        ${SP_APPID_SOURCES}
#        ${UTIL_APPID_SOURCES}
#    )
#endif (STATIC_INSPECTORS)

target_include_directories ( appid PRIVATE ${APPID_INCLUDE_DIR} )

add_subdirectory(service_plugins/test)
add_subdirectory(detector_plugins/test)
add_subdirectory(client_plugins/test)
add_subdirectory(test)

install (FILES ${APPID_INCLUDES}
    DESTINATION "${INCLUDE_INSTALL_PATH}/network_inspectors/appid"
)

=== src/network_inspectors/kaizen/CMakeLists.txt ===
add_library(kaizen OBJECT
    kaizen_engine.cc
    kaizen_engine.h
    kaizen_inspector.cc
    kaizen_inspector.h
    kaizen_module.cc
    kaizen_module.h
)

=== debian/changelog ===
snort (3.1.82.0-0kali1) kali-dev; urgency=medium

  * New upstream version 3.1.82.0

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 18 Mar 2024 15:16:04 +0100

snort (3.1.78.0-0kali1) kali-dev; urgency=medium

  * Use libdaq3-dev
  * Add superficial autopkgtest
  * New upstream version 3.1.78.0
  * Update debian/copyright

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 07 Feb 2024 17:25:46 +0100

snort (3.1.76.0-0kali1) kali-dev; urgency=medium

  * New upstream version 3.1.76.0

 -- Steev Klimaszewski <steev@kali.org>  Tue, 19 Dec 2023 14:11:11 -0600

snort (3.1.75.0-2) kali-dev; urgency=medium

  * Fix FTBFS on armel

 -- Steev Klimaszewski <steev@kali.org>  Tue, 12 Dec 2023 19:33:41 -0600

snort (3.1.75.0-1) kali-dev; urgency=medium

  * New upstream version 3.1.75.0

 -- Steev Klimaszewski <steev@kali.org>  Fri, 01 Dec 2023 15:56:38 -0600

snort (3.1.73.0-0kali2) kali-dev; urgency=medium

  * Update Maintainer field
  * Update Vcs-* fields
  * Add GitLab's CI configuration file
  * Configure git-buildpackage for Kali
  * Fix debian/NEWS
  * Bump Standards-Version to 4.6.2
  * Remove obsolete cron.daily and adapt logrotate
  * Fix for build on armel

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 29 Nov 2023 13:56:42 +0100

snort (3.1.73.0-0kali1) kali-dev; urgency=medium

  * Update debian/watch for snort version 3
  * New upstream version 3.1.73.0
  * Refresh patches
  * Add missing build-deps
  * Remove obsolete build-deps and deps
  * Use debhelper-compat 13
  * Update installation
  * Remove obsolete debian files and adapt installation
  * Clean maintainer scripts
  * Remove debconf files (no longer used in postinst)
  * Use systemd
  * Clean debian/rules
  * Update docs and remove old docs
  * Adapt README.Debian for version 3
  * Add debian/NEWS

 -- Sophie Brun <sophie@offensive-security.com>  Tue, 28 Nov 2023 16:14:33 +0100

=== debian/control ===
Source: snort
Section: net
Priority: optional
XSBC-Original-Maintainer: Javier Fernández-Sanguino Peña <jfs@debian.org>
Maintainer: Kali Developers <devel@kali.org>
Uploaders: Andrew Pollock <apollock@debian.org>
Build-Depends: 
    cmake,
    libnet1-dev, 
    libpcap0.8-dev, 
    libpcre3-dev, 
    debhelper-compat (= 13), 
    po-debconf (>= 0.5.0), 
    libdumbnet-dev, 
    libdaq3-dev (>=3.0.0),
    flex, 
    bison,
    pkg-config,
    zlib1g-dev,
    liblzma-dev,
    libluajit-5.1-dev,
    libnghttp2-dev,
    libfl-dev,
    libhwloc-dev,
    libssl-dev
Build-Depends-Indep: 
    texlive, 
    texlive-binaries, 
    texlive-latex-base, 
    texlive-font-utils,
    latex2html,
    ghostscript
Standards-Version: 4.6.2
Homepage: https://www.snort.org/
XS-Debian-Vcs-Git: https://salsa.debian.org/jfs/pkg-snort.git
XS-Debian-Vcs-Browser: https://salsa.debian.org/jfs/pkg-snort
Vcs-Git: https://gitlab.com/kalilinux/packages/snort.git
Vcs-Browser: https://gitlab.com/kalilinux/packages/snort

Package: snort
Architecture: any
Pre-Depends: adduser (>= 3.11), ${misc:Pre-Depends}
Depends: 
    snort-common-libraries (>=${binary:Version}),
    snort-rules-default (>= ${source:Version}), 
    snort-common (>= ${source:Version}),
    debconf (>= 0.2.80) | debconf-2.0,
    rsyslog | system-log-daemon,
    logrotate,
    net-tools,
    ${shlibs:Depends},
    ${misc:Depends}
Conflicts: 
    snort-mysql, 
    snort-pgsql
Replaces: snort-common (<< 2.0.2-3)
Recommends: iproute2
Suggests: snort-doc
Description: flexible Network Intrusion Detection System
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides the plain-vanilla version of Snort.

Package: snort-common
Architecture: all
Pre-Depends: adduser (>= 3.11), dpkg (>= 1.17.14), ${misc:Pre-Depends}
Depends: 
    perl, 
    debconf (>= 0.2.80) | debconf-2.0,
    ${shlibs:Depends},
    ${misc:Depends}
Conflicts: snort (<< ${binary:Version})
Replaces: snort (<< 1.8.4beta1-1)
Suggests: snort-doc
Description: flexible Network Intrusion Detection System - common files
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This is a common package which holds cron jobs, tools, and config files
 used by all the different package flavors.

Package: snort-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Section: doc
Description: flexible Network Intrusion Detection System - documentation
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides the documentation for Snort.

Package: snort-rules-default
Provides: snort-rules
Architecture: all
Depends: 
    debconf (>= 0.2.80) | debconf-2.0, 
    adduser (>= 3.11), 
    ${shlibs:Depends}, 
    ${misc:Depends}
Suggests: snort (>= 2.2.0) | snort-pgsql (>= 2.2.0) | snort-mysql (>= 2.2.0)
Recommends: oinkmaster
Homepage: http://www.snort.org/snort-rules/
Description: flexible Network Intrusion Detection System - ruleset
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This is the Snort default ruleset, which provides a basic set of network
 intrusion detection rules developed by the Snort community. They can be
 used as a basis for development of additional rules. Users using Snort to
 defend networks in production environments are encouraged to update their
 local rulesets as described in the included documentation or using the
 oinkmaster package.

Package: snort-common-libraries
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: snort (>= 2.7.0) | snort-pgsql (>= 2.7.0) | snort-mysql (>= 2.7.0)
Conflicts: snort-common (<< 2.7.0-6)
Description: flexible Network Intrusion Detection System - libraries
 Snort is a libpcap-based packet sniffer/logger which can be used as a
 lightweight network intrusion detection system. It features rules-based
 logging and can perform content searching/matching in addition to
 detecting a variety of other attacks and probes, such as buffer
 overflows, stealth port scans, CGI attacks, SMB probes, and much more.
 Snort has a real-time alerting capability, with alerts being sent to
 syslog, a separate "alert" file, or even to a Windows computer via Samba.
 .
 This package provides libraries used by all the Snort binary packages.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

# Enable all hardening features as Snort is a network "listener" of sorts
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifeq (armel, $(DEB_HOST_ARCH))
	export DEB_LDFLAGS_MAINT_APPEND =  -Wl,--no-as-needed -Wl,-latomic -Wl,--as-needed
endif

%:
	dh $@ 

override_dh_auto_test-indep:

=== debian/tests/control ===
Test-command: snort --help && snort2lua --help
Restrictions: superficial, needs-root

=== debian/watch ===
version=4
https://www.snort.org/downloads/ /downloads/snortplus/snort3-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
